Subject: bug#61142: 29.0.60; java-ts-mode - Wrong indentation for the body of multiple lines conditions

From: Eli Zaretskii <[email-masked]>
Date: Sun, 05 Feb 2023 11:20:27 +0200

> Cc: [email-masked]
> Date: Sun, 05 Feb 2023 08:53:33 +0100
> From:  Theodor Thornhill via "Bug reports for GNU Emacs,
>  the Swiss army knife of text editors" <[email-masked]>
> 
> Theodor Thornhill <[email-masked]> writes:
> 
> > 太阳 <[email-masked]> writes:
> >
> >> After reading treesit's manual, I found that we can use `n-p-gp` as the matcher
> >> and `grand-parent` as the anchor to match the body of `if` (and `while`, which
> >> has a similar issue).
> >>
> >> I mean a rule looks like the following:
> >>
> >> ```
> >> ((n-p-gp nil "block" "if_statement") grand-parent java-ts-mode-indent-offset)
> >> ```
> >>
> >>
> >
> >
> > Thanks!  We have a mechanism in place for this, see
> > 'c-ts-common-statement-offset' in 'c-ts-common.el'.  I didn't get to it
> > yet, but I'll try to look at it this evening, unless you want to?  See
> > c-ts-mode for examples of how to use it, if you're interested!
> >
> > Theo
> 
> Hi again!
> 
> Can you test this patch for me?
> 
> @Eli: Is this ok for emacs-29?  I'd love to add some test for this, but
> now they are on the master branch.  What is the common procedure to move
> stuff from master branch to the release branch?  I _can_ just add some
> test to the master branch, but it would be nice to have them on emacs-29
> too :-)

The procedure is "git cherry-pick", but I don't think I understand
what exactly is the problem here and what is the solution suggested to
solve it.  Also, why does it need to be on emacs-29.  Can you help me
understand that?

Thanks.